=== modified file 'dev.cfg'
--- dev.cfg	2006-12-13 08:53:38 +0000
+++ dev.cfg	2006-12-13 23:52:52 +0000
@@ -41,10 +41,11 @@
 # unexpected parameter. False by default
 tg.strict_parameters = True
 
-loggerhead.folder='/Users/robey/code/paramiko/paramiko'
-loggerhead.branch_name='paramiko-dev'
-#loggerhead.folder='/Users/robey/code/bzr/bzr.dev'
-#loggerhead.branch_name='bzr.dev'
+#loggerhead.folder='/Users/robey/code/paramiko/paramiko'
+#loggerhead.branch_name='paramiko-dev'
+loggerhead.folder='/Users/robey/code/bzr/bzr.dev'
+loggerhead.branch_name='bzr.dev'
+loggerhead.cachepath='/Users/robey/code/bzr/bzr.dev/.bzr/loggerhead-cache'
 loggerhead.external_url="http://localhost:8080"
 
 

=== added file 'loggerhead/TODO'
--- loggerhead/TODO	1970-01-01 00:00:00 +0000
+++ loggerhead/TODO	2006-12-13 23:52:52 +0000
@@ -0,0 +1,17 @@
+
+* maybe put this at the footer of each page:
+    paramiko-dev, 419 revisions, 1133 days old
+    first revision: Tue 2003-11-04 08:34:24 +0000
+    latest revision: Sat 2006-12-02 18:33:34 -0800
+    ...or somewhere.
+    
+* the cache-building in History.from_branch() should be an actual on-disk
+  cache.  for bzr.dev it takes almost 6 seconds.  also, each 'get_change()'
+  call takes almost 1 second.  cache those too.
+
+* add back the search bar.
+
+* add next/prev revision to the bottom of revision_ui.
+
+* some of the pages still aren't updated for start_revid.
+* put branch-nick in merge info?

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2006-12-13 03:02:49 +0000
+++ loggerhead/controllers/__init__.py	2006-12-13 23:52:52 +0000
@@ -27,6 +27,8 @@
 from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.annotate_ui import AnnotateUI
+from loggerhead.history import History
+from loggerhead import util
 
 
 log = logging.getLogger("loggerhead.controllers")
@@ -41,3 +43,7 @@
     @turbogears.expose()
     def index(self):
         raise HTTPRedirect(turbogears.url('/changes'))
+
+
+# force history to be read:
+util.get_history()

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2006-12-13 05:43:00 +0000
+++ loggerhead/controllers/annotate_ui.py	2006-12-13 23:52:52 +0000
@@ -21,11 +21,11 @@
 import os
 import posixpath
 import textwrap
+import time
 
 import turbogears
 from cherrypy import HTTPRedirect, session
 
-from loggerhead.history import History
 from loggerhead import util
 
 
@@ -42,7 +42,9 @@
 
     @turbogears.expose(html='loggerhead.templates.annotate')
     def default(self, *args, **kw):
-        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
+        z = time.time()
+        h = util.get_history()
+        
         if len(args) > 0:
             revid = args[0]
         else:
@@ -76,6 +78,8 @@
             'history': h,
             'navigation': navigation,
             'change': h.get_change(revid),
-            'contents': h.annotate_file(file_id, revid),
+            'contents': list(h.annotate_file(file_id, revid)),
         }
+        h.flush_cache()
+        log.info('/annotate: %r secs' % (time.time() - z,))
         return vals

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2006-12-11 19:23:51 +0000
+++ loggerhead/controllers/atom_ui.py	2006-12-13 23:52:52 +0000
@@ -18,15 +18,15 @@
 
 import turbogears
 
-from loggerhead.history import History
 from loggerhead import util
 
 
 class AtomUI (object):
-
+    
     @turbogears.expose(template='loggerhead.templates.atom', format="xml", content_type="application/atom+xml")
     def default(self, *args):
-        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
+        h = util.get_history()
+        
         if len(args) > 0:
             revid = args[0]
         else:
@@ -43,4 +43,5 @@
             'scan_url': '/changes',
             'updated': entries[0].date.isoformat() + 'Z',
         }
+        h.flush_cache()
         return vals

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-13 08:53:38 +0000
+++ loggerhead/controllers/changelog_ui.py	2006-12-13 23:52:52 +0000
@@ -25,7 +25,6 @@
 import turbogears
 from cherrypy import HTTPRedirect, session
 
-from loggerhead.history import History
 from loggerhead import util
 
 log = logging.getLogger("loggerhead.controllers")
@@ -48,10 +47,12 @@
 
 
 class ChangeLogUI (object):
-
+    
     @turbogears.expose(html='loggerhead.templates.changelog')
     def default(self, *args, **kw):
-        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
+        z = time.time()
+        h = util.get_history()
+        
         if len(args) > 0:
             revid = args[0]
         else:
@@ -84,7 +85,7 @@
         
         vals = {
             'branch_name': turbogears.config.get('loggerhead.branch_name'),
-            'changes': entries,
+            'changes': list(entries),
             'util': util,
             'history': h,
             'revid': revid,
@@ -95,8 +96,6 @@
             'last_revid': h.last_revid,
             'start_revid': start_revid,
         }
-        if kw.get('style', None) == 'rss':
-            vals['tg_template'] = 'loggerhead.templates.changelog-rss'
-            vals['tg_format'] = 'xml'
-            vals['tg_content_type'] = 'application/rss+xml'
+        h.flush_cache()
+        log.info('/changes %r: %r secs' % (revid, time.time() - z))
         return vals

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2006-12-13 03:02:49 +0000
+++ loggerhead/controllers/inventory_ui.py	2006-12-13 23:52:52 +0000
@@ -21,11 +21,11 @@
 import os
 import posixpath
 import textwrap
+import time
 
 import turbogears
 from cherrypy import HTTPRedirect, session
 
-from loggerhead.history import History
 from loggerhead import util
 
 
@@ -42,7 +42,9 @@
 
     @turbogears.expose(html='loggerhead.templates.inventory')
     def default(self, *args, **kw):
-        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
+        z = time.time()
+        h = util.get_history()
+        
         if len(args) > 0:
             revid = args[0]
         else:
@@ -87,4 +89,6 @@
             'posixpath': posixpath,
             'navigation': navigation,
         }
+        h.flush_cache()
+        log.info('/inventory %r: %r secs' % (revid, time.time() - z))
         return vals

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-13 08:53:38 +0000
+++ loggerhead/controllers/revision_ui.py	2006-12-13 23:52:52 +0000
@@ -20,11 +20,11 @@
 import logging
 import os
 import textwrap
+import time
 
 import turbogears
 from cherrypy import HTTPRedirect, session
 
-from loggerhead.history import History
 from loggerhead import util
 
 log = logging.getLogger("loggerhead.controllers")
@@ -34,7 +34,9 @@
 
     @turbogears.expose(html='loggerhead.templates.revision')
     def default(self, *args, **kw):
-        h = History.from_folder(turbogears.config.get('loggerhead.folder'))
+        z = time.time()
+        h = util.get_history()
+        
         if len(args) > 0:
             revid = args[0]
         else:
@@ -54,7 +56,7 @@
         buttons = [
             ('top', turbogears.url('/changes')),
             ('files', turbogears.url([ '/files', revid ])),
-            ('history', turbogears.url('/changes', start_revid=revid, path=path)),
+            ('history', turbogears.url('/changes', start_revid=revid)),
         ]
         
         navigation = util.Container(buttons=buttons, revlist=revlist, revid=revid, start_revid=start_revid, path=path,
@@ -68,4 +70,6 @@
             'history': h,
             'navigation': navigation,
         }
+        h.flush_cache()
+        log.info('/revision: %r seconds' % (time.time() - z,))
         return vals

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-13 08:53:38 +0000
+++ loggerhead/history.py	2006-12-13 23:52:52 +0000
@@ -18,8 +18,13 @@
 
 import cgi
 import datetime
+import logging
+import os
 import posixpath
+import shelve
 import textwrap
+import threading
+import time
 from StringIO import StringIO
 
 import bzrlib
@@ -32,17 +37,17 @@
 
 from loggerhead import util
 
-
-
+log = logging.getLogger("loggerhead.controllers")
 
 
 class History (object):
     
     def __init__(self):
-        pass
+        self._change_cache = None
 
     @classmethod
     def from_branch(cls, branch):
+        z = time.time()
         self = cls()
         self._branch = branch
         self._history = branch.revision_history()
@@ -70,12 +75,47 @@
             for parent in self._revision_graph[revid]:
                 self._where_merged.setdefault(parent, set()).add(revid)
 
+        log.info('build cache: %r' % (time.time() - z,))
         return self
     
     @classmethod
     def from_folder(cls, path):
         b = bzrlib.branch.Branch.open(path)
         return cls.from_branch(b)
+
+    def use_cache(self, path):
+        if not os.path.exists(path):
+            os.mkdir(path)
+        # keep a separate cache for the diffs, because they're very time-consuming to fetch.
+        cachefile = os.path.join(path, 'changes')
+        cachefile_diffs = os.path.join(path, 'changes-diffs')
+        
+        # why can't shelve allow 'cw'?
+        if not os.path.exists(cachefile):
+            self._change_cache = shelve.open(cachefile, 'c', protocol=2)
+        else:
+            self._change_cache = shelve.open(cachefile, 'w', protocol=2)
+        if not os.path.exists(cachefile_diffs):
+            self._change_cache_diffs = shelve.open(cachefile_diffs, 'c', protocol=2)
+        else:
+            self._change_cache_diffs = shelve.open(cachefile_diffs, 'w', protocol=2)
+            
+        # once we process a change (revision), it should be the same forever.
+        log.info('Using change cache %s; %d, %d entries.' % (path, len(self._change_cache), len(self._change_cache_diffs)))
+        self._cache_lock = threading.Lock()
+        self._change_cache_filename = cachefile
+        self._change_cache_diffs_filename = cachefile_diffs
+    
+    def flush_cache(self):
+        # shelve seems to need the file to be closed to save anything :(
+        self._cache_lock.acquire()
+        try:
+            self._change_cache.close()
+            self._change_cache_diffs.close()
+            self._change_cache = shelve.open(self._change_cache_filename, 'w', protocol=2)
+            self._change_cache_diffs = shelve.open(self._change_cache_diffs_filename, 'w', protocol=2)
+        finally:
+            self._cache_lock.release()
     
     last_revid = property(lambda self: self._last_revid, None, None)
     
@@ -147,6 +187,7 @@
         if revid is None:
             revid = self._last_revid
         if path is not None:
+            # since revid is 'start_revid', possibly should start the path tracing from revid... FIXME
             inv = self._branch.repository.get_revision_inventory(revid)
             revlist = list(self.get_short_revision_history_by_fileid(inv.path2id(path)))
         else:
@@ -164,12 +205,6 @@
         except:
             return []
     
-    def get_left_child(self, revid):
-        for r in self.get_where_merged(revid):
-            if self._revision_graph[r][0] == revid:
-                return r
-        return None
-
     def get_merge_point_list(self, revid):
         """
         Return the list of revids that have merged this node.
@@ -222,6 +257,37 @@
             yield self.get_change(revid)
     
     def get_change(self, revid, get_diffs=False):
+        if self._change_cache is None:
+            return self._get_change(revid, get_diffs)
+
+        # if the revid is in unicode, use the utf-8 encoding as the key
+        srevid = revid
+        if isinstance(revid, unicode):
+            srevid = revid.encode('utf-8')
+        self._cache_lock.acquire()
+        try:
+            if get_diffs:
+                cache = self._change_cache_diffs
+            else:
+                cache = self._change_cache
+            
+            if srevid in cache:
+                c = cache[srevid]
+            else:
+                log.debug('Entry cache miss: %r' % (revid,))
+                c = self._get_change(revid, get_diffs=get_diffs)
+                cache[srevid] = c
+            
+            # some data needs to be recalculated each time, because it may
+            # change as new revisions are added.
+            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
+            c.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
+            
+            return c
+        finally:
+            self._cache_lock.release()
+    
+    def _get_change(self, revid, get_diffs=False):
         try:
             rev = self._branch.repository.get_revision(revid)
         except (KeyError, bzrlib.errors.NoSuchRevision):
@@ -231,20 +297,21 @@
                 'revno': '',
                 'date': datetime.datetime.fromtimestamp(0),
                 'author': 'missing',
-                'age': 'unknown',
+                'branch_nick': None,
                 'short_comment': 'missing',
+                'comment': 'missing',
+                'comment_clean': 'missing',
                 'parents': [],
+                'merge_points': [],
+                'changes': [],
             }
+            log.error('ghost entry: %r' % (revid,))
             return util.Container(entry)
             
-        now = datetime.datetime.now()
         commit_time = datetime.datetime.fromtimestamp(rev.timestamp)
         
         parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in rev.parent_ids]
 
-        merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
-        merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
-        
         if len(parents) == 0:
             left_parent = None
         else:
@@ -265,13 +332,11 @@
             'revno': self.get_revno(revid),
             'date': commit_time,
             'author': rev.committer,
-            'age': util.timespan(now - commit_time) + ' ago',
+            'branch_nick': rev.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': rev.message,
             'comment_clean': [util.html_clean(s) for s in message],
             'parents': parents,
-            'merge_points': merge_points,
-            'left_child': self.get_left_child(revid),
             'changes': self.diff_revisions(revid, left_parent, get_diffs=get_diffs),
         }
         return util.Container(entry)
@@ -449,6 +514,7 @@
         pass
 
     def annotate_file(self, file_id, revid):
+        z = time.time()
         lineno = 1
         parity = 0
         
@@ -456,27 +522,29 @@
         oldvalues = None
         revision_cache = {}
         
-        for revno_str, author, date_str, line_rev_id, text in bzrlib.annotate._annotate_file(self._branch, file_revid, file_id):
-            # remember which lines have a new revno and which don't
-            if revno_str == '':
-                revno, author, line_rev_id, change = oldvalues
+        # because we cache revision metadata ourselves, it's actually much
+        # faster to call 'annotate_iter' on the weave directly than it is to
+        # ask bzrlib to annotate for us.
+        w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
+        last_line_revid = None
+        for line_revid, text in w.annotate_iter(file_revid):
+            if line_revid == last_line_revid:
+                # remember which lines have a new revno and which don't
                 status = 'same'
             else:
-                revno = self.get_revno(line_rev_id)
-                change = revision_cache.get(line_rev_id, None)
-                if change is None:
-                    change = self.get_change(line_rev_id)
-                    revision_cache[line_rev_id] = change
-                oldvalues = (revno, author, line_rev_id, change)
                 status = 'changed'
                 parity ^= 1
-                
-            
-            trunc_revno = revno
-            if len(revno) > 10:
-                trunc_revno = revno[:9] + '...'
-                
-            yield util.Container(parity=parity, lineno=lineno, revno=revno, author=author, status=status,
+                last_line_revid = line_revid
+                change = revision_cache.get(line_revid, None)
+                if change is None:
+                    change = self.get_change(line_revid)
+                    revision_cache[line_revid] = change
+                trunc_revno = change.revno
+                if len(trunc_revno) > 10:
+                    trunc_revno = trunc_revno[:9] + '...'
+                
+            yield util.Container(parity=parity, lineno=lineno, status=status,
                                  trunc_revno=trunc_revno, change=change, text=util.html_clean(text))
             lineno += 1
-
+        
+        log.debug('annotate: %r secs' % (time.time() - z,))

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2006-12-13 08:53:38 +0000
+++ loggerhead/static/css/style.css	2006-12-13 23:52:52 +0000
@@ -408,6 +408,10 @@
     width: 6em;
 }
 
+span.folder {
+    font-family: monospace;
+}
+
 
 /* ----- file annotation ----- */
 

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2006-12-13 05:43:00 +0000
+++ loggerhead/templates/annotate.kid	2006-12-13 23:52:52 +0000
@@ -55,8 +55,8 @@
         <tr py:for="line in contents" class="parity${line.parity}">
             <td class="lineno ${line.status}"> ${line.lineno} </td>
             <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${tg.url([ '/revision', line.change.revid ], path=path)}"
-                    title="${line.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${line.change.age})">${line.trunc_revno}</a>
+                <a py:if="line.status=='changed'" href="${tg.url('/revision', start_revid=line.change.revid, path=path)}"
+                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${line.trunc_revno}</a>
             </td>
             <!--td class="author"> ${util.hide_email(line.author)} </td-->
             <td class="text ${line.status}"> ${XML(line.text)} </td>

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2006-12-13 08:53:38 +0000
+++ loggerhead/templates/changelog.kid	2006-12-13 23:52:52 +0000
@@ -83,7 +83,7 @@
 			        </tr>
 			        <tr>
 			            <th class="date">date:</th>
-			            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${entry.age}) </td>
+			            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
 			        </tr>
 			    </table>
 			</div>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2006-12-13 03:02:49 +0000
+++ loggerhead/templates/inventory.kid	2006-12-13 23:52:52 +0000
@@ -44,7 +44,7 @@
     </table>
 </div>
 
-folder: <span class="folder"> ${path} </span>
+<b>folder:</b> <span class="folder"> ${path} </span>
 
 <table class="inventory" width="100%">
     <tr class="header">

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2006-12-13 08:53:38 +0000
+++ loggerhead/templates/revision.kid	2006-12-13 23:52:52 +0000
@@ -26,13 +26,17 @@
         <tr py:if="len(change.merge_points) > 0">
             <th class="children"> merged in: </th>
             <td class="children">
-                <span py:for="child in change.merge_points"> ${revlink(child.revid, '(' + child.revno + ')')} &nbsp; </span>
+                <span py:for="child in change.merge_points">
+                    ${revlink_path(child.revid, child.revid, '(' + child.revno + ')', None)} &nbsp; 
+                </span>
             </td>
         </tr>
         <tr py:if="len(change.parents) > 1">
         	<th class="parents"> merged from: </th>
         	<td class="parents">
-        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid"> ${revlink(parent.revid, '(' + parent.revno + ')')} &nbsp; </span></span>
+        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
+        	        ${revlink_path(parent.revid, parent.revid, '(' + parent.revno + ')', None)} &nbsp;
+        	    </span></span>
         	</td>
         </tr>
 

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2006-12-13 01:45:10 +0000
+++ loggerhead/util.py	2006-12-13 23:52:52 +0000
@@ -17,8 +17,12 @@
 #
 
 import cgi
+import datetime
 import re
 import sha
+import threading
+
+import turbogears
 
 
 def timespan(delta):
@@ -51,6 +55,11 @@
     return ', '.join(seg)
 
 
+def ago(timestamp):
+    now = datetime.datetime.now()
+    return timespan(now - timestamp) + ' ago'
+    
+
 class Container (object):
     """
     Convert a dict into an object with attributes.
@@ -157,4 +166,22 @@
         return '-rwxr-xr-x'
     return '-rw-r--r--'
 
-        
+
+# global branch history & cache
+
+_history = None
+_history_lock = threading.Lock()
+
+def get_history():
+    global _history
+    from loggerhead.history import History
+    
+    _history_lock.acquire()
+    try:
+        if _history is None:
+            _history = History.from_folder(turbogears.config.get('loggerhead.folder'))
+            _history.use_cache(turbogears.config.get('loggerhead.cachepath'))
+        return _history
+    finally:
+        _history_lock.release()
+

